
### DGP


#setwd('E:/research/fangying_yingxing/simulation files')

rm(list=ls(all=TRUE))

library(lme4)
library(RLRsim)
library(nlme)
source('other4.r')

para1=rbind(c(1,0,0,0,0),c(1,0,0,1,0),c(1,0,0,0,1),c(1,0,0,1,1),
c(1,0,0.5,0,0),c(1,0,0.5,1,0),c(1,0,0.5,0,1),c(1,0,0.5,1,1))

para2=rbind(c(0,1,0,0,0),c(0,1,0,1,0),c(0,1,0,0,1),c(0,1,0,1,1),
c(0,1,0.5,0,0),c(0,1,0.5,1,0),c(0,1,0.5,0,1),c(0,1,0.5,1,1))

n=300;

para=para2;

sink(file="res_0810_100power.txt")

colnames(para)=c("mod1","mod2","rou","simu","cov_est")
store=para1=NULL;
for(t2 in 1:8){

c1=para[t2,1];
c2=para[t2,2];
rou0=para[t2,3];
simu=para[t2,4];
cov_est=para[t2,5];
para3=c(n,para[t2,]);

cc=c(c1,c2);
theta=function(t,cc){cc[1]*(t-0.5)^0+cc[2]*(t-0.5)^2};  ## constant

p=1; ## linear TPS;
sigma2_eps=1;

nstep=1;
stat=rep(0,2000);
seed0=1253;
while(nstep<2000) {
set.seed(seed0+nstep);

z=runif(n);
v=rnorm(n)
x=cumsum(v);

error=sqrt(sigma2_eps)*rnorm(n)
if(rou0!=0){
error=arima.sim(n=n, list(ar=c(rou0)), sd=1)}

Y = x*theta(z, cc)+error   #sqrt(sigma2_eps)*rnorm(n);

Y=rev(Y);
x=rev(x);
z=rev(z);

Xall=as.matrix(x, ncol=1);
Tz=rep(1, n)
for (i in 1:p) {
Tz1=cbind(Tz, z^{i});
 }

num.knots=max(20, min(floor(length(unique(z))/4), 35))
myknots = quantile ( unique(z),  seq(0,1, length=(num.knots+2))[-c(1, (num.knots+2))] )
Tz2=outer(z, myknots, FUN="-")  
Tz3 = Tz2* (Tz2 >0) 
if(p>1) Tz3=Tz3^p. 
TXall=diag(x)%*%Tz1;
TZall=diag(x)%*%Tz3;

cov=diag(1,n);
if(rou0!=0){
cov[col(cov) == (row(cov)+1) ] <- -rou0;  # creat a uptriangle matrix
}

## estimate the AR model for the residuals
if(cov_est==1){
ma=lme_est(TXall, TZall, Y, df=1);
rs=resid(ma);
rou1=ar(rs)$ar;
qq=length(rou1);
if(qq>0){
for(i in 1:qq){
cov[col(cov) == (row(cov)+i) ] <- -rou1[i];  # creat a uptriangle matrix
}
         }
              }

cLRTv=LRTval(TXall, TZall, Y, df=1,Sigma.output=cov)[1]
stat[nstep]=cLRTv;
nstep=nstep+1;
}
cv99=qchisq(0.99, p)
cv95=qchisq(0.95, p)
cv90=qchisq(0.90, p)
cv85=qchisq(0.85, p)
cv80=qchisq(0.80, p)

if(simu==1)
{
sim.LRT<-LRTSim(cov%*%TXall, cov%*%TZall,q=p,diag(num.knots));
cv99=quantile(sim.LRT,0.99)
cv95=quantile(sim.LRT,0.95)
cv90=quantile(sim.LRT,0.90)
cv85=quantile(sim.LRT,0.85)
cv80=quantile(sim.LRT,0.80)
}
temp=rep(0,5)
temp[1]=sum(stat>cv90)/length(stat)
temp[2]=sum(stat>cv95)/length(stat)
temp[3]=sum(stat>cv99)/length(stat)
temp[4]=sum(stat>cv85)/length(stat)
temp[5]=sum(stat>cv80)/length(stat)
res1=c(para3,temp);
print(res1);
print("#########################################");
store=rbind(store,res1);
}

write.csv(store,"res0810_power100.csv")





 