
## sigma.ouput: default covariance matrix;
LRTval=function(X, Z, Y, df, Sigma.output=diag(rep(1, length(Y)))){

n=length(Y)
Xnames = paste("X",1:ncol(X),sep="") 
Znames = paste("Z",1:ncol(Z),sep="") 

fixed.model = as.formula(paste("DATA.temp ~ -1+",paste(paste("X",1:ncol(X),sep=""),collapse="+")))   
fixed.model2 = as.formula(paste("DATA.temp ~ -1+",paste(paste("X",1:(ncol(X)-df),sep=""),collapse="+")))   

random.model = as.formula(paste("~-1+",paste(paste("Z",1:ncol(Z),sep=""),collapse="+")))   

DATA.output = as.vector( Sigma.output  %*% Y )  ## this return the N-dimensional vector of DATA ; N=n*m
Xhat = Sigma.output %*% X ; 
Zhat = Sigma.output %*% Z

DATA.temp= DATA.output
dimnames(Xhat)[[2]]=Xnames
dimnames(Zhat)[[2]]=Znames
subject<-rep(1,n)
ALLDATA  = data.frame(cbind(subject,DATA.temp, Xhat, Zhat))
mA = lme(fixed=fixed.model, data=ALLDATA, random=list(subject = pdIdent(random.model)), method="ML" ) 


m0 = lm(fixed.model2, data=ALLDATA)
obs.LRT = 2* (logLik(mA)- logLik(m0)) 
return(obs.LRT)
}


lme_est=function(X, Z, Y, df, Sigma.output=diag(rep(1, length(Y)))){

n=length(Y)
Xnames = paste("X",1:ncol(X),sep="") 
Znames = paste("Z",1:ncol(Z),sep="") 

fixed.model = as.formula(paste("DATA.temp ~ -1+",paste(paste("X",1:ncol(X),sep=""),collapse="+")))   
fixed.model2 = as.formula(paste("DATA.temp ~ -1+",paste(paste("X",1:(ncol(X)-df),sep=""),collapse="+")))   

random.model = as.formula(paste("~-1+",paste(paste("Z",1:ncol(Z),sep=""),collapse="+")))   

DATA.output = as.vector( Sigma.output  %*% Y )  ## this return the N-dimensional vector of DATA ; N=n*m
Xhat = Sigma.output %*% X ; 
Zhat = Sigma.output %*% Z

DATA.temp= DATA.output
dimnames(Xhat)[[2]]=Xnames
dimnames(Zhat)[[2]]=Znames
subject<-rep(1,n)
ALLDATA  = data.frame(cbind(subject,DATA.temp, Xhat, Zhat))
ma = lme(fixed=fixed.model, data=ALLDATA, random=list(subject = pdIdent(random.model)), method="ML" ) 
return(ma)
}





